/*
**  WASABI-Hot! version 1.2c   
**
**
**      -- copyright (c) 2001-2004 by Philips Japan, Ltd. -- All rights reserved --
**
**
**      ** This code has been made to check/learn                          ** 
**      **                             the ISP1362/ISP1363 functionalities **
**      ** Release 06-Aug-2004                                             **
**
**      OKANO, Akifumi
**      
**		Application Laboratory, Mobile and Connectivity
**      Semiconductors Div, Philips Japan Ltd.
**      akifumi.okano@philips.com
**      +81-3-3740-4668 
*/

#ifndef _GENERAL_H
#define _GENERAL_H

/****************************************************************************/
/*	constants																*/
/****************************************************************************/

//
//	Version definitions
//

#define			WASABI

//#define		VERSION_NUMBER		"0.1a"		//	
//#define		VERSION_NUMBER		"0.1b"		//	
//#define		VERSION_NUMBER		"0.7 "		//	25-Apr-2002
//#define		VERSION_NUMBER		"0.7a"		//	08-May-2002
//#define		VERSION_NUMBER		"0.8 "		//	08-May-2002	Scheduler works!
//#define		VERSION_NUMBER		"0.9 "		//	15-May-2002	First OTG release
//#define		VERSION_NUMBER		"0.9a"		//	22-May-2002	OTG for ISA and PCI, more stable
//#define		VERSION_NUMBER		"0.9b"		//	24-May-2002	ES3 indication / PCI-brige-setting IO detect added
//#define		VERSION_NUMBER		"0.9c"		//	27-May-2002 New DC code
//#define		VERSION_NUMBER		"0.9d"		//	11-Jun-2002 Remote WAV file local play
//#define		VERSION_NUMBER		"0.9e"		//	14-Jun-2002 New OTG-FSM
//#define		VERSION_NUMBER		"0.9f"		//	24-Jun-2002 For DEMO @ Show:ESEC   (@ Tokyo 26..28-Jun-2002)
//#define		VERSION_NUMBER		"0.9g"		//	02-Jul-2002 Minor fixes : not released
//#define		VERSION_NUMBER		"1.0 "		//	03-Jul-2002 First official release
//#define		VERSION_NUMBER		"1.0a"		//	12-Jul-2002 Minor fixes
//#define		VERSION_NUMBER		"1.0b"		//	22-Jul-2002 ES4 detection, Audio peak meter improve, Mouse interface addition
//#define		VERSION_NUMBER		"1.0c"		//	05-Aug-2002 Minor UI fixes
//#define		VERSION_NUMBER		"1.0d"		//	05-Aug-2002 Final release for version 1.0 series
												//	Following version 1.0 codes will be released as service release
//#define		VERSION_NUMBER		"1.0e"		//	04-Oct-2002 
//#define		VERSION_NUMBER		"1.0f"		//	30-Nov-2002 
//#define		VERSION_NUMBER		"1.0g"		//	XX-Dec-2002 
												//	Following version 1.1 codes are having test implementation for storage
//#define		VERSION_NUMBER		"1.1-"		//	24-Feb-2003 
//#define		VERSION_NUMBER		"1.1a"		//	04-Mar-2003 
//#define		VERSION_NUMBER		"1.1b"		//	XX-Mar-2003 
												//	Following version 1.2 codes are the code for storage support
//#define		VERSION_NUMBER		"1.2 "		//	10-Jun-2003 
//#define		VERSION_NUMBER		"1.2a"		//	27-Aug-2003 
//#define		VERSION_NUMBER		"1.2b"		//	08-Dec-2003 
#define			VERSION_NUMBER		"1.2c"		//	06-Aug-2004 

//#define		VERSION_CODE_NAME	"ep32"		//	1.2 
//#define		VERSION_CODE_NAME	"63en"		//	1.2a
//#define		VERSION_CODE_NAME	"swear"		//	1.2b
#define			VERSION_CODE_NAME	"atom"		//	1.2c



//
//	Compile option switches
//

//#define		PURE_DOS						//	##	version1.2c
												//	Enable this, if the application runs on "pure DOS" only. It does not work on Windows 
												//	environment. This option may give better performance in DOS env. 
												//	Without this "pure DOS" option, the application works on DOS and Windows env. 
												
//#define		Use_DMA							//	Please keep turned-OFF. Version 0.9x does not support DMA. PCI board does not support DMA
//#define		TESTPRINT						//	to show control transfer progress (debug purpose)
//#define		SHOW_SING_BUFFER_STATUS			//	Buffer status monitor enable for "sing.c" debug
//#define		USE_DOUBLE_BUFFER_FOR_DEV_EP4	//	To use double buffer for EP4 in DC to transmit audio data.
#define			PER_PORT_POWER_SWITCHING		//	##	version1.2c
//#define		PORT1_AS_HOST_ONLY				//	Port1 setting : to make port1 as fixed host port.
#define			USE_AUDIO_PEAK_METER			//	Enable audio peak meter feature. It works in DOS-environment mode.
#define			SMALLER_ISO_BUFFER				//	To save buffer usage for isochronous transfer.
												//	This will make iso (ISTL0 + ISTL1) buffer size to 1848 bytes and ATL block size 512.
												//	Also the INTL blocks will be 10.

#define			USE_PAIRED_PTD					//	For strage operation : to use paired-PTD





//	
//	General constants
//

#define		Enabled					1
#define		Disabled				0

#define		error					1
#define		no_error				0

#define		True					1
#define		False					0


/****************************************************************************/
/*	macros																	*/
/****************************************************************************/

#ifdef TESTPRINT	//	to show control transfer progress (debug purpose)
#define		testprint( x, y )		mprintf( x, CONTINUE, y )
#else		
#define		testprint( x, y )
#endif


#ifdef	PURE_DOS

#define		disable_INT()			disable()
#define		enable_INT()			enable()

#else	//	PURE_DOS

#define		disable_INT()			hwacces_isr_hw_disable()
#define		enable_INT()			hwacces_isr_hw_enable()

#endif	//	PURE_DOS


/****************************************************************************/
/*	global vars																*/
/****************************************************************************/

extern char							gp_app_name[ 13 ];
extern char							gp_app_path_name[ 128 ];
extern char							*gp_host_name[];
extern unsigned char				gp_chip_version_index;
extern unsigned char				gp_version_display;
extern unsigned char				gp_is_in_DOS_environment;


/****************************************************************************/
/*	function prototypes														*/
/****************************************************************************/

void			gene_maintenance_process( void );

void			*gene_install_asynchronous_periodic_process( unsigned char number, void (* func)( void ) );
void 			wait_ms( unsigned long timeout );

unsigned short	short_swap( unsigned short x );
unsigned long	long_swap( unsigned long x );


#endif